/*jslint nomen: true, plusplus: true, todo: true, white: true, browser: true, indent: 2 */

jQuery(function($) {
  'use strict';

  // Set variable for toggles.
  var $editor_toggle = $('#edit-plaintext-enabled');

  // Unobstrusive syntax highlighting.
  var $textarea = $('#css-editor-textarea');

  var createEditor = function() {
    var editor = CodeMirror.fromTextArea($textarea[0], { lineNumbers : true, extraKeys : { "Ctrl-Space" : "autocomplete" } });
    return editor;
  };

  var editor = createEditor();

  // Initial state of the editor checkbox.
  if ($editor_toggle.is(':checked')) {
    editor.toTextArea();
  }

  $editor_toggle.on('click', function() {
    if ($(this).is(':checked')) {
      editor.toTextArea();
    }
    else {
      editor = createEditor();
    }
  });

});
