<?php

namespace Drupal\book_pdfs\Controller;

use Drupal\book_pdfs\BookPdfsGenerator;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\BinaryFileResponse;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\node\Entity\Node;

class BookPdfsController extends ControllerBase {

  protected $generator;

  public function __construct(BookPdfsGenerator $generator) {
    $this->generator = $generator;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('book_pdfs.generator')
    );
  }

  public function sendPdf(Request $request, Node $book) {
    if (($filePath = $this->generator->getFileUri($book))) {
      return new BinaryFileResponse($filePath, 200, ['Content-Type' => 'application/pdf']);
    }
    else {
      \Drupal::messenger()->addError('Unable to retrieve the PDF at this time.');
      return new RedirectResponse($request->server->get('HTTP_REFERER'));
    }
  }
}

